/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.bescheid.common.callcontext;

import java.io.Serializable;
import java.util.Collection;
import java.util.Optional;

import org.springframework.security.core.AuthenticatedPrincipal;

import lombok.Builder;
import lombok.Getter;
import lombok.Singular;

@Builder
@Getter
public class CallContextUser implements AuthenticatedPrincipal, Serializable {

	private static final long serialVersionUID = 1L;

	private final String clientName;

	@Builder.Default
	private final transient Optional<String> userId = Optional.empty();
	@Builder.Default
	private final transient Optional<String> userName = Optional.empty();
	@Singular
	private final Collection<String> organisatorischeEinheitenIds;
	@Builder.Default
	private final transient boolean organisationEinheitenIdCheckNecessary = false;

	@Override
	public String getName() {
		return clientName;
	}

}
