package de.ozgcloud.bescheid.common.freemarker;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.mock.mockito.MockBean;

import de.ozgcloud.apilib.common.command.OzgCloudCommandService;
import de.ozgcloud.apilib.common.command.grpc.CommandMapper;
import de.ozgcloud.common.test.ITCase;

@ITCase
class TemplateHandlerITCase {

	private static final String BESCHEID_TEMPLATE = "dummy.template.txt.ftlh";

	@Autowired
	private TemplateHandler handler;
	@MockBean
	private OzgCloudCommandService commandService;
	@MockBean
	private CommandMapper commandMapper;

	@DisplayName("Get raw template")
	@Nested
	class TestGetRawTemplate {

		@Test
		void shouldReturnTemplateAsString() {
			var content = handler.getRawTemplate(BESCHEID_TEMPLATE);

			assertThat(content)
					.contains("Sehr geehrte/r Antragsteller/in")
					.contains("im folgenden wird evtl was ersetzt")
					.contains("valueToReplace")
					.contains("Mit freundlichen Grüßen");
		}
	}
}
